local visW, visH, fs = 49, 31, 16
mapW, mapH = 30, 30
roomCol = 7
nodeW, nodeH = 1, 1


require("bsp")
require("fov")

units = {}
units[1]	=	{	id		= 1,
				x		= 10,
				y		= 10,
				walkable	= 0,
				glyph		= "@",
				name		= "hero",
				color		= {255,255,255,255},
				spd		= 10,
				path		= {},
				action	= {"moveRnd",0,10},
				timer		= 0
			}

function love.load()
	fontDeja = love.graphics.newFont("DejaVuSansMono.ttf", fs)
	love.graphics.setFont(fontDeja)
	math.randomseed(os.time())
	math.random()
	math.random()
	math.random()
	octans = {}
	map = {}	
	generateMap(0, 18, "na")
	repeat
		x = math.random(mapW)
		y = math.random(mapH)
	until map[y][x].walkable == 1
	units[1].x, units[1].y = x, y
end

function love.keypressed(key)
	if key == "escape" then
		love.event.push("q")
	end
	if key == "return" then
		octans = {}
		map = {}
		generateMap(0, 18, "na")
		repeat
			x = math.random(mapW)
			y = math.random(mapH)
		until map[y][x].walkable == 1
		units[1].x, units[1].y = x, y
	end
	if key == "0" then
		if roomCol < 20 then
			roomCol= roomCol + 1
		end
	end
	if key == "9" then
		if roomCol > 3 then
			roomCol= roomCol - 1
		end
	end

	x = units[1].x
	y = units[1].y
	units[1].action = {"___",0,0,10}

	if key == "left" and map[y][x-1].walkable == 1 then
		units[1].action = {"___",-1,0,10}
	end
	if key == "right" and map[y][x+1].walkable == 1 then
		units[1].action = {"___",1,0,10}
	end
	if key == "up" and map[y-1][x].walkable == 1 then
		units[1].action = {"___",0,-1,10}
	end
	if key == "down" and map[y+1][x].walkable == 1 then
		units[1].action = {"___",0,1,10}
	end
	
	units[1].x = x + units[1].action[2]
	units[1].y = y + units[1].action[3]

	octans = {}
	for v=1,8 do
		newScan(v,2,1,0)
	end

end


function love.draw()
	love.graphics.print("max columns per room = "..roomCol, 0, 550)
	love.graphics.print("less = 9    /    more = 0", 0, 570)
	local ww, hh = (visW+1)/2, (visH+1)/2
	love.graphics.setColor(200,200,200,170)
	for y = 1+units[1].y-hh, visH+units[1].y-hh do
		for x = 1+units[1].x-ww, visW+units[1].x-ww do
			if map[y] then
				if map[x] then
					love.graphics.print(map[y][x].glyph, (x-1-units[1].x+ww)*fs, (y-1-units[1].y+hh)*fs)
					love.graphics.print(units[1].glyph, (ww-1)*fs, (hh-1)*fs)
				end
			end
		end
	end
	
	if octans then
		love.graphics.setColor(0,255,55,170)
		for i,v in ipairs(octans) do
			love.graphics.print("O", (v.x-1-units[1].x+ww)*fs, (v.y-1-units[1].y+hh)*fs)				
		end
	end
end
